/* 
 * File:   typedefs.h
 * Author: peter
 *
 * Created on 06. Dezember 2012, 14:18
 */

#ifndef TYPEDEFS_H
#define	TYPEDEFS_H

using namespace std;

class Perftres {
public:
    Perftres(int dep) {
        depth=dep;
        for (int i=0;i<140;i++)
            perftres[i]=0;
    };
    long print_info() {
        long sum=0;

        for (int i=0;i<depth;i++) {
            cout    <<      "Depth: "       << (i+1) <<
                            " Nodes: "     << perftres[i*7] <<
                            " Captures: "  << perftres[1+i*7] <<
                            " Checks: "    << perftres[2+i*7] <<
                            " Mates: "     << perftres[3+i*7] <<
                            " E.p.: "      << perftres[4+i*7] <<
                            " Promot.:"    << perftres[5+i*7] <<
                            " Castl.:"     << perftres[6+i*7] << endl;
            sum+=perftres[i*7];
        }
        return sum;        
    };
    int getSize() {
        return 140;
    };
    long perftres[140];
    int depth;    
private:
};

struct backup {
    unsigned long aw;
    unsigned long ab;
    unsigned long all;
    unsigned long kings[2];
    unsigned long pawns[2];
    unsigned long bishops[2];
    unsigned long knights[2];
    unsigned long queens[2];
    unsigned long rooks[2];    
    unsigned long targetmap;    
    short int ep;
    bool white_castling_short;
    bool white_castling_long;
    bool black_castling_short;
    bool black_castling_long;  
    bool onMove;
};

#endif	/* TYPEDEFS_H */

