/* 
 * File:   Perft.h
 * Author: peter
 *
 * Created on 01. Februar 2012, 12:15
 */

#ifndef PERFT_H
#define	PERFT_H

#include <list>
#include "Position.h"
#include "typedefs.h"

// typedef boost::ptr_list<string> PositionList;
// typedef boost::ptr_list<string>::iterator PositionIterator;

struct threadData {
    Position pos;
//    PositionList childlist;
    int curr_depth;
    int max_depth;
    int fromIndex;
    int toIndex;
    Perftres *result;
};

class Perft {
public:
    Perft() {};
    Perft(Position &pos, int max_depth);
    void doPerftList();
    void doPerft(string fen, int max_depth);
    void doPseudoPerft(Position &pos, int max_depth);
    void getChildsPseudo(Position &pos, int depth, long &sum);
    void print_info();
    
private:
    // int doLevel1(Position &pos, int curr_depth, int max_depth);
    // static void *doThread(void *threadarg);
};

#endif	/* PERFT_H */

