#!/usr/bin/php
<?php

function extractFEN($content) {
	preg_match_all('/{(.*)}/i',$content,$fen);
	$fen=$fen[1][0];
	$fen=substr($fen,2,strlen($fen)-4);
	$fen=substr($fen,0,strrpos($fen," "));
	$fen=substr($fen,0,strrpos($fen," "));
	return $fen;
}
/*
function parseMoves($moves) {
	global $pipes;
	$moves=str_replace("+","",$moves);
//	echo $moves . "\n\n";

	$cmd="position startpos moves";


	$moves=explode(" ",$moves);


	fputs($pipes[0], "fen\n");

	foreach ($moves as $move) {
		$cmd.=" ".$move;
//		echo $cmd . "\n";
    		fputs($pipes[0], $cmd."\n");
		fputs($pipes[0], "fen\n");
		$posfen=substr(fgets($pipes[1]),5);
		$posfen=str_replace("\n","",$posfen);
		echo $posfen . "," . $move ."\n";
	}
	$endfen=str_replace("\n","",substr(fgets($pipes[1]),5));
//	echo $endfen . "\n";
	return $endfen;
}
*/
function parseMoves2($moves,$won) {
	global $pipes;
	$moves=str_replace("+","",$moves);
//	echo $moves . "\n\n";

	$cmd="position startpos";
	fputs($pipes[0], $cmd."\n");

	$moves=explode(" ",$moves);


	fputs($pipes[0], "fen\n");

	foreach ($moves as $move) {
		$cmd="position moves ".$move;
//		echo $cmd . "\n";
    		fputs($pipes[0], $cmd."\n");
		fputs($pipes[0], "fen\n");
		$posfen=substr(fgets($pipes[1]),5);
		$posfen=str_replace("\n","",$posfen);
		echo $posfen . "," . $move . "," . $won . "\n";
	}
	$endfen=str_replace("\n","",substr(fgets($pipes[1]),5));
//	echo $endfen . "\n";
	return $endfen;
}

function extractMoves($content,$won) {
	$start=strrpos($content,"]")+1;
	$end=strrpos($content,"#");
	$moves=trim(substr($content,$start,$end-$start));
	$moves=strtolower($moves);
	return parseMoves2($moves,$won);
}

function extractWon($content) {
	$content=trim($content);
	$start=strrpos($content," ")+1;
	if (substr($content,$start,1)==1)
		return "w";
	else
		return "b";
}

function fetchPGN($content) {
	global $gamesWhiteCheckmated,$gamesBlackCheckmated;


	$content=str_replace("\n"," ",$content);

	$won=extractWon($content);

//	echo $won."\n";


	$endfen=extractMoves($content,$won);

	$fen = extractFEN($content);
	return ($endfen==$fen);
}

function fetchFile($filename) {
	if (file_exists($filename)) {
		$handle=fopen($filename,"r");
		$content="";
		while (!feof($handle)) {
			$content.= fgets($handle, 8192);
		}
		fclose($handle);
		// echo $content;
		return fetchPGN($content);
	} else
		echo $filename . "\tcan't read file\n";
}


$descriptorspec = array(
   0 => array("pipe", "r"),  // stdin
   1 => array("pipe", "w"),  // stdout
   2 => array("file", "/tmp/error-output.txt", "a") // stderr
);

$cwd = '/tmp';
$process = proc_open('/home/peter/ChessPraktikum/madlenka silent', $descriptorspec, $pipes, $cwd, null);



$path="./extracted/";
if ($handle=opendir($path)) {
	while(false!==($entry=readdir($handle))) {
		$file=$path.$entry;
		if (is_file($file)) {
//			echo $file.", ".fetchFile($file)."\n";
			fetchFile($file);
//			break;
		}
	}
}


fputs($pipes[0], "quit\n");
fclose($pipes[0]);
fclose($pipes[1]); 



$return_value = proc_close($process);
// echo "command returned $return_value\n";

?>
