#!/usr/bin/php
<?php

function parseRow($row) {
	$row=trim($row);
	$values=explode(";",$row);

	$rowsum=0;
	foreach ($values as $value) {
		if (strlen($value))
			$rowsum+=$value;
	}

	foreach ($values as $value) {
		if (strlen($value)) {
			if ($value>0)
				echo ($value/$rowsum);
			else
				echo $value;
			echo ";";
		}
	}
	echo "\n";
}

function fetchFile($filename) {
	$handle=fopen($filename,"r");
	while (!feof($handle)) {
		$row=fgets($handle, 8192);
		if (strlen($row))
			parseRow($row);
	}
	fclose($handle);
}

if (sizeof($argv)==1)
  die("no file given.\n");
else {
	$file=$argv[1];
	if (file_exists($file) && is_file($file))
		fetchFile($file);
	else
		die("error, can't open file.\n");
}

?>
