/* 
 * File:   Logger.h
 * Author: peter
 *
 * Created on 22. Dezember 2012, 17:50
 */

#ifndef EVALSTAT_H
#define	EVALSTAT_H

using namespace std;

class Evalstat {
public:
    Evalstat() {
        pFile = fopen ("magdalena-evalstat.txt","a");
        if (pFile==NULL)
            cout << "can't write to log file" << endl;    
    };
    
    virtual ~Evalstat() {
        if (pFile!=NULL)
            fclose(pFile);
    };
    
    void logFenScore(string fen, int sc0, int sc1, int sc2, int sc3, int sc4, int sc5, int sc6, int sc7, int sc8, int sc9, int sc10, int sc11, int sc12, int sc13, int sc14, int sc15) {
        if (fen.size()>0 && pFile!=NULL) {
            fen.append(",");
            fen.append(int2String(sc0));
            fen.append(",");
            fen.append(int2String(sc1));            
            fen.append(",");
            fen.append(int2String(sc2));
            fen.append(",");
            fen.append(int2String(sc3));
            fen.append(",");
            fen.append(int2String(sc4));
            fen.append(",");
            fen.append(int2String(sc5));
            fen.append(",");
            fen.append(int2String(sc6));
            fen.append(",");
            fen.append(int2String(sc7));
            fen.append(",");
            fen.append(int2String(sc8));
            fen.append(",");
            fen.append(int2String(sc9));
            fen.append(",");
            fen.append(int2String(sc10));
            fen.append(",");
            fen.append(int2String(sc11));
            fen.append(",");
            fen.append(int2String(sc12));
            fen.append(",");
            fen.append(int2String(sc13));
            fen.append(",");
            fen.append(int2String(sc14));
            fen.append(",");
            fen.append(int2String(sc15));
            fen.append("\n");
            fputs (fen.data(),pFile);
        }        
    }
private:
    FILE * pFile;
};

#endif	/* LOGGER_H */

