/* 
 * File:   globals.h
 * Author: peter
 *
 * Created on 06. Dezember 2012, 13:27
 */

#ifndef GLOBALS_H
#define	GLOBALS_H

using namespace std;

int string2int(string str);
long string2long(string str);
string int2String(int value);
string long2string(long value);
string double2String(double value);
string getBoolString(bool value);
bool figOnPos(const unsigned long &figure, const int &position);
string nicerCmd(string command);

#include "HashT.h"
#include "MoveList.h"
#include "Timer.h"
#include "Logger.h"
#include "Evalstat.h"

extern HashT hashTable;
extern MoveList moveList;
extern Timer timer;
extern Logger logger;
extern Evalstat evalstat;

#define CAPTURE_NONE 0
#define CAPTURE_PAWN 1
#define CAPTURE_KNIGHT 2
#define CAPTURE_BISHOP 3
#define CAPTURE_ROOK 4
#define CAPTURE_QUEEN 5
#define CAPTURE_KING 6
#define CAPTURE_MASK 15

extern unsigned short int distances[64][64];

#endif	/* GLOBALS_H */

