<?php
	include("xajax_core/xajax.inc.php");
	$xajax = new xajax();


	function retpow($c) {
		$a=1;
		for ($i=0;$i<$c;$i++) $a=bcmul($a,2);
		return $a;
	}

	$xajax->registerFunction("calc_decs");
	function calc_decs($arg1,$arg2) {
		$arg1=strrev($arg1);
		$res=0;
		for($i=0;$i<strlen($arg1)-1;$i++) {
			if ($arg1[$i]=='1') $res=bcadd(retpow($i),$res);
		}
		if ($arg1[63]=='1')
			$res=bcsub($res,bcpow(2,63));
	  	$objResponse = new xajaxResponse();
		$objResponse->assign("dez".$arg2,"value",$res);
		return $objResponse;
	}

	$xajax->registerFunction("calc_or");
	function calc_or($arg1,$arg2) {
		$str="";
		for ($i=0;$i<64;$i++) {
			if ($arg1[$i]==1 || $arg2[$i]==1) $str.="1";
			else $str.="0";
		}


	  	$objResponse = new xajaxResponse();
		$objResponse->assign("bin3","value",$str);
		$res=0;
		$str=strrev($str);
		for($i=0;$i<strlen($str)-1;$i++) {
			if ($str[$i]=='1') $res=bcadd(retpow($i),$res);
		}
		if ($str[63]=='1')
			$res=bcsub($res,bcpow(2,63));
		$objResponse->assign("dez3","value",$res);

		// $str=strrev($str);
		for($i=0;$i<64;$i++) {
			$x=$i%8;
			$y=floor($i/8);
			if (($x%2==0 && $y%2==1) || ($x%2==1 && $y%2==0))	{
				if ($str[$i]==1)	$objResponse->assign("2m".$i,"className","field_b_selected");
				else 			$objResponse->assign("2m".$i,"className","field_b");
			}
			else {
				if ($str[$i]==1)	$objResponse->assign("2m".$i,"className","field_w_selected");
				else			$objResponse->assign("2m".$i,"className","field_w");
			}
		}
		return $objResponse;
	}

	$xajax->registerFunction("calc_xor");
	function calc_xor($arg1,$arg2) {
		$str="";
		for ($i=0;$i<64;$i++) {
			if ($arg1[$i] <> $arg2[$i]) $str.="1";
			else $str.="0";
		}
	  	$objResponse = new xajaxResponse();
		$objResponse->assign("bin3","value",$str);
		$res=0;
		$str=strrev($str);
		for($i=0;$i<strlen($str)-1;$i++) {
			if ($str[$i]=='1') $res=bcadd(retpow($i),$res);
		}
		if ($str[63]=='1')
			$res=bcsub($res,bcpow(2,63));
		$objResponse->assign("dez3","value",$res);
		// $str=strrev($str);
		for($i=0;$i<64;$i++) {
			$x=$i%8;
			$y=floor($i/8);
			if (($x%2==0 && $y%2==1) || ($x%2==1 && $y%2==0))	{
				if ($str[$i]==1)	$objResponse->assign("2m".$i,"className","field_b_selected");
				else 			$objResponse->assign("2m".$i,"className","field_b");
			}
			else {
				if ($str[$i]==1)	$objResponse->assign("2m".$i,"className","field_w_selected");
				else			$objResponse->assign("2m".$i,"className","field_w");
			}
		}
		return $objResponse;
	}

	$xajax->registerFunction("calc_and");
	function calc_and($arg1,$arg2) {
		$str="";
		for ($i=0;$i<64;$i++) {
			if ($arg1[$i]==1 && $arg2[$i]==1) $str.="1";
			else $str.="0";
		}
	  	$objResponse = new xajaxResponse();
		$objResponse->assign("bin3","value",$str);
		$res=0;
		$str=strrev($str);
		for($i=0;$i<strlen($str)-1;$i++) {
			if ($str[$i]=='1') $res=bcadd(retpow($i),$res);
		}
		if ($str[63]=='1')
			$res=bcsub($res,bcpow(2,63));
		$objResponse->assign("dez3","value",$res);
		// $str=strrev($str);
		for($i=0;$i<64;$i++) {
			$x=$i%8;
			$y=floor($i/8);
			if (($x%2==0 && $y%2==1) || ($x%2==1 && $y%2==0))	{
				if ($str[$i]==1)	$objResponse->assign("2m".$i,"className","field_b_selected");
				else 			$objResponse->assign("2m".$i,"className","field_b");
			}
			else {
				if ($str[$i]==1)	$objResponse->assign("2m".$i,"className","field_w_selected");
				else			$objResponse->assign("2m".$i,"className","field_w");
			}
		}
		return $objResponse;
	}

	$xajax->processRequest();
?>
<html>
<head>
  <title>Bitboard</title>
  <link rel="stylesheet" type="text/css" href="formate.css">
	<?php $xajax->printJavascript(); ?>	
  <script type="text/javascript">
	<!--
    		<?php include("jscript.php"); ?>
	//-->
  </script>
</head>
<body onload="clean_boards()">
<h4>BitBoard-Operator for Chess by Peter Garscha / indi [at] mindplace [dot] net</h4>
<table align="center" width="1400px">
<tr>
  <td valign="top" align="center">Board A
    <?php $board=0; include("show_board.php"); ?>
  </td>
  <td valign="top" align="center">Board B
    <?php $board=1; include("show_board.php"); ?>
  </td>
  <td valign="top" align="center">Board C
    <?php $board=2; include("show_board.php"); ?>
  </td>
</tr>
<tr>
  <td colspan="3" valign="top"><br /><br />
    <form action="index.php" method="post">
      	Board A: <input id="bin1" name="bin1" type="text" value="" size="70" /><input id="dez1" name="dez1" type="text" value="" size="40" /><br />
    	Board B: <input id="bin2" name="bin2" type="text" value="" size="70" /><input id="dez2" name="dez2" type="text" value="" size="40" /><br />
      	Board C: <input id="bin3" name="bin3" type="text" value="" size="70" /><input id="dez3" name="dez3" type="text" value="" size="40" /><br /><br />
	<input type="button" name="refresh" value="Refresh Boards" onclick="clean_boards()">
	<input type="button" name="or" value="OR (a=1 or b=1)" onclick="xajax_calc_or(document.getElementById('bin1').value,document.getElementById('bin2').value)">
	<input type="button" name="xor" value="XOR (a<>b)" onclick="xajax_calc_xor(document.getElementById('bin1').value,document.getElementById('bin2').value)">
	<input type="button" name="and" value="AND (a=1 and b=1)" onclick="xajax_calc_and(document.getElementById('bin1').value,document.getElementById('bin2').value)">
    </form>
  </td>
</tr>
</table>
</body>
</html>
